diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/ossusb/usbmidi.c oss-v4.1test0-070624-src-gpl/kernel/drv/ossusb/usbmidi.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/ossusb/usbmidi.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/ossusb/usbmidi.c	Tue Jun 26 22:19:41 2007
@@ -180,7 +180,7 @@
   if (midic->open_mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   midic->open_mode = mode;
@@ -196,7 +196,7 @@
 	{
 	  usb_midi_close (dev, mode);
 	  cmn_err (CE_WARN, "Cannot open midi output pipe\n");
-	  return -ENOMEM;
+	  return RETERR(ENOMEM);
 	}
 
       if ((devc->output_pipe =
@@ -223,7 +223,7 @@
 	{
 	  usb_midi_close (dev, mode);
 	  cmn_err (CE_WARN, "Cannot open midi input pipe\n");
-	  return -ENOMEM;
+	  return RETERR(ENOMEM);
 	}
       if ((devc->input_pipe =
 	   udi_usb_alloc_request (midic->usbdev, midic->in_endpoint_handle, 1,
@@ -238,7 +238,7 @@
 	{
 	  cmn_err (CE_CONT, "oss usbmidi: Input error %d\n", err);
 	  usb_midi_close (dev, mode);
-	  return -EIO;
+	  return RETERR(EIO);
 	}
     }
 
@@ -279,7 +279,7 @@
 static int
 usb_midi_ioctl (int dev, unsigned cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static int
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/s3vibes/s3vibes.c oss-v4.1test0-070624-src-gpl/kernel/drv/s3vibes/s3vibes.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/s3vibes/s3vibes.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/s3vibes/s3vibes.c	Tue Jun 26 22:19:41 2007
@@ -210,7 +210,7 @@
 vibes_mixer_get (vibes_devc * devc, int dev)
 {
   if (!((1 << dev) & MIXER_DEVS))
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   return devc->levels[dev];
 }
@@ -383,7 +383,7 @@
 	  }
     }
   else
-    return -EINVAL;
+    return RETERR(EINVAL);
 }
 
 static mixer_driver_t vibes_mixer_driver = {
@@ -436,7 +436,7 @@
 static int
 vibes_audio_ioctl (int dev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void
@@ -495,7 +495,7 @@
   if (devc->audio_open_mode & mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   devc->audio_open_mode |= mode;
@@ -694,14 +694,14 @@
 
   cmn_err (CE_WARN, "S3 SonicVibes: Input timed out. Ptr %x, addr %x\n", tmp,
 	   addr);
-  return -EIO;
+  return RETERR(EIO);
 }
 
 static int
 vibes_check_output (int dev)
 {
   cmn_err (CE_WARN, "S3 SonicVibes: Output timed out.\n");
-  return -EIO;
+  return RETERR(EIO);
 }
 
 #if 0
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/sblive/sblive.c oss-v4.1test0-070624-src-gpl/kernel/drv/sblive/sblive.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/sblive/sblive.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/sblive/sblive.c	Tue Jun 26 22:19:41 2007
@@ -668,19 +668,19 @@
     case SBLIVE_WRITEPARMS:
       {
 	if (gpr->ngpr >= MAX_GPR_PARMS)
-	  return -EIO;
+	  return RETERR(EIO);
 
 	for (i = 0; i < gpr->ngpr; i++)
 	  {
 	    gpr->gpr[i].name[GPR_NAME_SIZE - 1] = 0;	/* Overflow protection */
 	    if (strlen (gpr->gpr[i].name) >= 32)	/* Name may be bad */
 	      {
-		return -EIO;
+		return RETERR(EIO);
 	      }
 
 	    if (gpr->gpr[i].num >= MAX_GPR)
 	      {
-		return -EIO;
+		return RETERR(EIO);
 	      }
 
 /* cmn_err(CE_CONT, "Gpr %d = %s (vol %x) type=%x\n", gpr->gpr[i].num, gpr->gpr[i].name, gpr->gpr[i].def, gpr->gpr[i].type); */
@@ -703,7 +703,7 @@
 	    if (devc->gpr == NULL)
 	      {
 		cmn_err (CE_CONT, "SB Live: Out of memory (gpr)\n");
-		return -ENOSPC;
+		return RETERR(ENOSPC);
 	      }
 	    memset (devc->gpr, 0, sizeof (gpr_info));
 	  }
@@ -716,13 +716,13 @@
     case SBLIVE_WRITECONST:
       {
 	if (consts->nconst >= MAX_CONST_PARMS)
-	  return -EIO;
+	  return RETERR(EIO);
 
 	for (i = 0; i < consts->nconst; i++)
 	  {
 	    if (consts->consts[i].gpr >= MAX_GPR)
 	      {
-		return -EIO;
+		return RETERR(EIO);
 	      }
 
 	    sblive_write_reg (devc, consts->consts[i].gpr + GPR0, 0,
@@ -763,7 +763,7 @@
       break;
 
     }
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void sblive_audio_trigger (int dev, int state);
@@ -826,7 +826,7 @@
   if (portc->mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   portc->mode = mode;
@@ -851,7 +851,7 @@
       if (!setup_passthrough (devc, portc, 1))
 	{
 	  portc->mode = 0;
-	  return -EBUSY;
+	  return RETERR(EBUSY);
 	}
     }
   else
@@ -1569,7 +1569,7 @@
   if (audio_engines[dev]->flags & ADEV_NOINPUT)
     {
       cmn_err (CE_CONT, "SB Live: Audio device %d is output only\n", dev);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   if (dmap->buffsize > 65536)
@@ -1606,7 +1606,7 @@
     default:
       cmn_err (CE_CONT, "SB Live error: Unsupported input buffer size %d\n",
 	       dmap->buffsize);
-      return -ENOSPC;
+      return RETERR(ENOSPC);
     }
 
   if (portc->input_type == ITYPE_SPDIF)
@@ -1649,7 +1649,7 @@
   int voiceL = portc->voice_chn, voiceR = portc->voice_chn + 1;
 
   if (audio_engines[dev]->flags & ADEV_NOOUTPUT)
-    return -EIO;
+    return RETERR(EIO);
 
   /* AC3 needs stereo too */
   if (portc->format == AFMT_AC3 || portc->input_type == ITYPE_SPDIF)
@@ -1724,7 +1724,7 @@
 	oss_free_dmabuf (dev, dmap);
 	dmap->dmabuf = NULL;
 
-	return -ENOSPC;
+	return RETERR(ENOSPC);
       }
 
   if (direction == PCM_ENABLE_OUTPUT)
@@ -1759,14 +1759,14 @@
 sblive_check_input (int dev)
 {
   cmn_err (CE_CONT, "SBLive: Input timeout\n");
-  return -EIO;
+  return RETERR(EIO);
 }
 
 static int
 sblive_check_output (int dev)
 {
   cmn_err (CE_CONT, "SBLive: Output timeout\n");
-  return -EIO;
+  return RETERR(EIO);
 }
 
 static int
@@ -2125,7 +2125,7 @@
 
   if (devc->midi_opened)
     {
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   while (input_avail (devc))
@@ -2171,7 +2171,7 @@
 static int
 audigyuart_ioctl (int dev, unsigned cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static midi_driver_t audigy_midi_driver = {
@@ -2915,7 +2915,7 @@
     }
 
   if (ctrl < 0 || ctrl >= MAX_GPR)
-    return -EIO;
+    return RETERR(EIO);
 
   typ = MIXT_SLIDER;
   for (i = 0; i < devc->gpr->ngpr; i++)
@@ -2924,7 +2924,7 @@
 
   if (typ == MIXT_GROUP)
     {
-      return -EIO;
+      return RETERR(EIO);
     }
 
   if (cmd == SNDCTL_MIX_READ)
@@ -3027,7 +3027,7 @@
       return value;
     }
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static int
@@ -3037,7 +3037,7 @@
   sblive_portc *portc;
 
   if (ctrl < 0 || ctrl >= devc->n_audiodevs)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   portc = &devc->portc[ctrl];
 
@@ -3112,7 +3112,7 @@
 #endif
     }
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static int
@@ -3121,7 +3121,7 @@
   sblive_devc *devc = mixer_devs[dev]->hw_devc;
 
   if (ctrl < 0 || ctrl >= devc->n_audiodevs)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   if (cmd == SNDCTL_MIX_READ)
     {
@@ -3141,7 +3141,7 @@
       return peak_cnv[l] | (peak_cnv[r] << 8);
     }
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static int
@@ -3179,7 +3179,7 @@
 	}
     }
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static int
@@ -3299,7 +3299,7 @@
   devc->mixer_group = -1;
 
   if (devc->gpr->ngpr >= MAX_GPR_PARMS)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   for (i = 0; i < devc->gpr->ngpr; i++)
     {
@@ -3324,7 +3324,7 @@
       if (!group_created)
 	{
 	  cmn_err (CE_CONT, "SB Live: Mixer initialization sequence error\n");
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 	}
 #endif
       mode = MIXF_READABLE;
@@ -3441,7 +3441,7 @@
 	      portc = &devc->portc[i];
 
 	  if (portc == NULL)
-	    return -EIO;
+	    return RETERR(EIO);
 
 	  return portc->playvol | (portc->playvol << 8);
 	}
@@ -3459,7 +3459,7 @@
 	      portc = &devc->portc[i];
 
 	  if (portc == NULL)
-	    return -EIO;
+	    return RETERR(EIO);
 
 	  left = val & 0xff;
 	  right = (val >> 8) & 0xff;
@@ -3735,7 +3735,7 @@
 	{
 	  cmn_err (CE_CONT, "SBLive: Audio memory block exhausted (%d/%d)\n",
 		   devc->audio_memptr, AUDIO_MEMSIZE);
-	  return -ENOSPC;
+	  return RETERR(ENOSPC);
 	}
 
       if (i == 0)
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/softoss/softoss.c oss-v4.1test0-070624-src-gpl/kernel/drv/softoss/softoss.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/softoss/softoss.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/softoss/softoss.c	Tue Jun 26 22:19:41 2007
@@ -875,7 +875,7 @@
       break;
 
     default:
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 
 }
@@ -1246,7 +1246,7 @@
 	  cmn_err (CE_WARN, "Fatal error in setting up the sample format\n");
 	  oss_audio_release (devc->masterdev, &devc->finfo);
 	  stop_record_engine (devc);
-	  return -ENXIO;
+	  return RETERR(ENXIO);
 	}
 
   devc->masterdev_opened = 1;
@@ -1402,13 +1402,13 @@
   if (format != GUS_PATCH)
     {
       cmn_err (CE_WARN, "Invalid patch format (key) 0x%x\n", format);
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 
   if (count < sizeof_patch)
     {
       cmn_err (CE_WARN, "Patch header too short\n");
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 
   count -= sizeof_patch;
@@ -1416,7 +1416,7 @@
   if (devc->nrsamples >= MAX_SAMPLE)
     {
       cmn_err (CE_WARN, "Sample table full\n");
-      return -ENOSPC;
+      return RETERR(ENOSPC);
     }
 
   /*
@@ -1429,7 +1429,7 @@
   if (patch == NULL)
     {
       cmn_err (CE_WARN, "Out of memory\n");
-      return -ENOSPC;
+      return RETERR(ENOSPC);
     }
 
   uiomove ((caddr_t) & patch[offs], sizeof_patch - offs, UIO_WRITE, addr);
@@ -1438,7 +1438,7 @@
     {
       KERNEL_FREE (patch);
       cmn_err (CE_WARN, "Unsupported ROM patch\n");
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 
   instr = patch->instr_no;
@@ -1447,7 +1447,7 @@
     {
       cmn_err (CE_WARN, "Invalid program number %d\n", instr);
       KERNEL_FREE (patch);
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 
   if (count < patch->len)
@@ -1462,7 +1462,7 @@
       cmn_err (CE_WARN, "Invalid sample length %d\n", (int) patch->len);
       cmn_err (CE_WARN, "Possibly out of memory\n");
       KERNEL_FREE (patch);
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 
   if (patch->mode & WAVE_LOOPING)
@@ -1471,7 +1471,7 @@
 	{
 	  cmn_err (CE_WARN, "Invalid loop start %d\n", patch->loop_start);
 	  KERNEL_FREE (patch);
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 	}
 
       if (patch->loop_end < patch->loop_start || patch->loop_end > patch->len)
@@ -1479,7 +1479,7 @@
 	  cmn_err (CE_WARN, "Invalid loop start or end point (%d, %d)\n",
 		   patch->loop_start, patch->loop_end);
 	  KERNEL_FREE (patch);
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 	}
     }
 
@@ -1502,7 +1502,7 @@
       cmn_err (CE_WARN, "Can't allocate %d bytes of mem for a sample\n",
 	       memlen);
       KERNEL_FREE (patch);
-      return -ENOSPC;
+      return RETERR(ENOSPC);
     }
 
   p = 0;
@@ -1923,7 +1923,7 @@
       break;
     }
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void
@@ -1969,7 +1969,7 @@
   if (portc->open_mode != 0)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
   portc->open_mode = mode;
   if (mode & OPEN_READ)
@@ -2101,7 +2101,7 @@
   if (!devc->duplex_mode)
     {
       cmn_err (CE_WARN, "Audio device %d is playback only\n", dev);
-      return -ENOTSUP;
+      return RETERR(ENOTSUP);
     }
 
   v->channels = adev->hw_parms.channels;
@@ -2131,7 +2131,7 @@
   vmix_reset_output (dev);
 
   if (dmap->dmabuf == NULL)
-    return -ENOSPC;
+    return RETERR(ENOSPC);
   /* dmap->applic_profile = APF_CPUINTENS; */
 
   v = &softoss_avoices[voice];
@@ -2210,7 +2210,7 @@
   dmap->dmabuf_phys = 0;
   dmap->dmabuf = KERNEL_MALLOC (MY_BUFFSIZE);
   if (dmap->dmabuf == NULL)
-    return -ENOSPC;
+    return RETERR(ENOSPC);
   dmap->buffsize = MY_BUFFSIZE;
 
   return 0;
@@ -2410,7 +2410,7 @@
 softoss_mixer_get (softoss_devc * devc, int audiodev, int dev)
 {
   if (!((1 << dev) & MIXER_DEVS))
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   switch (dev)
     {
@@ -2440,7 +2440,7 @@
       break;
 
     default:
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 }
 
@@ -2450,7 +2450,7 @@
   int left, right, voice;
 
   if (!((1 << dev) & MIXER_DEVS))
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   left = value & 0x00ff;
   right = (value >> 8) & 0x00ff;
@@ -2514,7 +2514,7 @@
       break;
 
     default:
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 
   return value;
@@ -2571,7 +2571,7 @@
 	  }
     }
   else
-    return -EINVAL;
+    return RETERR(EINVAL);
 }
 
 static mixer_driver_t softoss_mixer_driver = {
@@ -2629,7 +2629,7 @@
   int left, right;
 
   if (ctrl < 0 || ctrl >= softoss_devices)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   if (cmd == SNDCTL_MIX_READ)
     {
@@ -2660,7 +2660,7 @@
       return left | (right << 8);
     }
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static const unsigned char peak_cnv[256] = {
@@ -2705,7 +2705,7 @@
   avoice_info *v;
 
   if (ctrl < 0 || ctrl >= softoss_devices)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   if (cmd == SNDCTL_MIX_READ)
     {
@@ -2716,7 +2716,7 @@
       return left | (right << 8);
     }
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static int
@@ -2728,7 +2728,7 @@
   int left, right;
 
   if (ctrl < 0 || ctrl >= softoss_devices)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   if (cmd == SNDCTL_MIX_READ)
     switch (ctrl)
@@ -2753,7 +2753,7 @@
 	break;
       }
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 #ifdef USE_EQ
@@ -2761,7 +2761,7 @@
 softoss_eq (int dev, int ctrl, unsigned int cmd, int value)
 {
   if (ctrl < 0 || ctrl > 5)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   if (cmd == SNDCTL_MIX_READ)
     {
@@ -2792,7 +2792,7 @@
 	value = 255;
       return devc->eq_bands[ctrl] = value;
     }
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 #endif
 
@@ -2964,7 +2964,7 @@
   effects_info_t *efc;
 
   if ((efc = devc->effects_info) == NULL)
-    return -EIO;
+    return RETERR(EIO);
 
   if (cmd == SNDCTL_MIX_READ)
     switch (ctrl)
@@ -3002,7 +3002,7 @@
 	break;
 
       default:
-	return -EINVAL;
+	return RETERR(EINVAL);
       }
 
   if (cmd == SNDCTL_MIX_WRITE)
@@ -3096,9 +3096,9 @@
 	break;
 
       default:
-	return -EINVAL;
+	return RETERR(EINVAL);
       }
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static int
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/softoss/softoss_loop.c oss-v4.1test0-070624-src-gpl/kernel/drv/softoss/softoss_loop.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/softoss/softoss_loop.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/softoss/softoss_loop.c	Tue Jun 26 22:19:41 2007
@@ -46,7 +46,7 @@
 static int
 softloop_ioctl (int dev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void softloop_trigger (int dev, int state);
@@ -112,7 +112,7 @@
   if (portc->is_opened)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   portc->is_opened = 1;
@@ -183,7 +183,7 @@
 static int
 softloop_prepare_for_output (int dev, int bsize, int bcount)
 {
-  return -EIO;
+  return RETERR(EIO);
 }
 
 static int
@@ -195,7 +195,7 @@
   dmap->dmabuf_phys = 0;	/* Not mmap() capable */
   dmap->dmabuf = KERNEL_MALLOC (MY_BUFFSIZE);
   if (dmap->dmabuf == NULL)
-    return -ENOSPC;
+    return RETERR(ENOSPC);
   dmap->buffsize = MY_BUFFSIZE;
 
   return 0;
@@ -226,7 +226,7 @@
   dmap_p dmap = audio_engines[dev]->dmap_in;
 
   if (dmap == NULL)
-    return -EIO;
+    return RETERR(EIO);
 
   if (devc->engine_state != ES_STOPPED)
     {
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/solo/solo.c oss-v4.1test0-070624-src-gpl/kernel/drv/solo/solo.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/solo/solo.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/solo/solo.c	Tue Jun 26 22:19:42 2007
@@ -323,17 +323,17 @@
 #endif
 
   if (dev > 31)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   if (!(SOLO_MIXER_DEVICES & (1 << dev)))	/*
 						 * Not supported
 						 */
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   regoffs = solo_mix[dev][LEFT_CHN].regno;
 
   if (regoffs == 0)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   val = solo_getmixer (devc, regoffs);
   change_bits (devc, &val, dev, LEFT_CHN, left);
@@ -377,7 +377,7 @@
     {
       val = *arg;
       if (val != 0 && val != 1)
-	return (-EINVAL);
+	return (RETERR(EINVAL));
 
       if (val)
 	{
@@ -438,7 +438,7 @@
 	  }
     }
   else
-    return -EINVAL;
+    return RETERR(EINVAL);
 }
 
 static void
@@ -614,7 +614,7 @@
 static int
 solo_audio_ioctl (int dev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void solo_audio_trigger (int dev, int state);
@@ -650,7 +650,7 @@
   if (portc->open_mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
   portc->open_mode = mode;
   portc->audio_enabled = ~mode;
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/trident/trident.c oss-v4.1test0-070624-src-gpl/kernel/drv/trident/trident.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/trident/trident.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/trident/trident.c	Tue Jun 26 22:19:42 2007
@@ -465,7 +465,7 @@
 static int
 trident_audio_ioctl (int dev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void trident_audio_trigger (int dev, int state);
@@ -501,7 +501,7 @@
   if (portc->open_mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
   portc->open_mode = mode;
   portc->audio_enabled = ~mode;
@@ -1022,14 +1022,14 @@
 trident_check_output (int dev)
 {
   cmn_err (CE_WARN, "Trident: Output Timed Out\n");
-  return -EIO;
+  return RETERR(EIO);
 }
 
 static int
 trident_check_input (int dev)
 {
   cmn_err (CE_WARN, "Trident: Input Timed Out\n");
-  return -EIO;
+  return RETERR(EIO);
 }
 
 static int
@@ -1101,7 +1101,7 @@
       cmn_err (CE_WARN, "Trident: Got DMA buffer address beyond 2G limit.\n");
       oss_free_dmabuf (dev, dmap);
       dmap->dmabuf = NULL;
-      return -ENOSPC;
+      return RETERR(ENOSPC);
     }
   return 0;
 }
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/via8233/via8233.c oss-v4.1test0-070624-src-gpl/kernel/drv/via8233/via8233.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/via8233/via8233.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/via8233/via8233.c	Tue Jun 26 22:19:42 2007
@@ -232,7 +232,7 @@
 static int
 via8233_audio_ioctl (int dev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void via8233_audio_trigger (int dev, int state);
@@ -268,13 +268,13 @@
   if (portc->open_mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   if (devc->open_mode & mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   devc->open_mode |= mode;
@@ -424,7 +424,7 @@
   if (portc->rec_engine == NULL)
     {
       cmn_err (CE_WARN, "via8233: No rec engine (dev=%d)\n", dev);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   MUTEX_ENTER_IRQDISABLE (devc->mutex, flags);
@@ -605,14 +605,14 @@
   if (portc->rec_engine == NULL)
     {
       cmn_err (CE_NOTE, "Input timed out\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   ptr = INL (devc->osdev, portc->rec_engine->base + 0x0c);
   if (ptr != 0)
     return 0;
   cmn_err (CE_NOTE, "Input timed out (%08x)\n", ptr);
-  return -EIO;
+  return RETERR(EIO);
 }
 
 static int
@@ -625,14 +625,14 @@
   if (portc->play_engine == NULL)
     {
       cmn_err (CE_NOTE, "Output timed out\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   ptr = INL (devc->osdev, portc->play_engine->base + 0x0c);
   if (ptr != 0)
     return 0;
   cmn_err (CE_NOTE, "Output timed out (%08x)\n", ptr);
-  return -EIO;
+  return RETERR(EIO);
 }
 
 static int
@@ -816,7 +816,7 @@
 	  if (eng->sgd == NULL)
 	    {
 	      cmn_err (CE_WARN, "via8233: can't allocate SGD table\n");
-	      return -ENOSPC;
+	      return RETERR(ENOSPC);
 	    }
 	  eng->sgd_phys = phaddr;
 	}
@@ -837,7 +837,7 @@
   if (via8233_alloc_engines (devc) < 0)
     {
       cmn_err (CE_WARN, "Unable to allocate engines\n");
-      return -ENOSPC;
+      return RETERR(ENOSPC);
     }
 
   /*
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/via97/via97.c oss-v4.1test0-070624-src-gpl/kernel/drv/via97/via97.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/via97/via97.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/via97/via97.c	Tue Jun 26 22:19:42 2007
@@ -267,7 +267,7 @@
 static int
 via97_audio_ioctl (int dev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void via97_audio_trigger (int dev, int state);
@@ -303,13 +303,13 @@
   if (portc->open_mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   if (devc->open_mode & mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   devc->open_mode |= mode;
@@ -423,7 +423,7 @@
   oss_native_word flags;
 
   if (audio_engines[dev]->dmap_out->dmabuf_phys == 0)
-    return -ENOSPC;
+    return RETERR(ENOSPC);
 
   MUTEX_ENTER_IRQDISABLE (devc->mutex, flags);
   tmp = 0x81;			/* Auto start at EOL, interrupt on FLAG */
@@ -442,7 +442,7 @@
       if (sgd_ptr >= SGD_TOTAL_SIZE)
 	{
 	  cmn_err (CE_WARN, "VIA97: Out of Record SGD entries\n");
-	  return -ENOSPC;
+	  return RETERR(ENOSPC);
 	}
 
       devc->SGD_table[sgd_ptr].phaddr =
@@ -473,7 +473,7 @@
   oss_native_word flags;
 
   if (audio_engines[dev]->dmap_out->dmabuf_phys == 0)
-    return -ENOSPC;
+    return RETERR(ENOSPC);
 
   MUTEX_ENTER_IRQDISABLE (devc->mutex, flags);
   tmp = 0x81;			/* Auto start at EOL, interrupt on FLAG */
@@ -493,7 +493,7 @@
       if (sgd_ptr >= SGD_TOTAL_SIZE)
 	{
 	  cmn_err (CE_WARN, "VIA97: Out of Playback SGD entries\n");
-	  return -ENOSPC;
+	  return RETERR(ENOSPC);
 	}
 
       devc->SGD_table[sgd_ptr].phaddr =
@@ -689,7 +689,7 @@
 	CONTIG_MALLOC (devc->osdev, SGD_ALLOC, MEMLIMIT_32BITS, &phaddr);
 
       if (devc->SGD_table == NULL)
-	return -ENOSPC;
+	return RETERR(ENOSPC);
       devc->SGD_table_phys = phaddr;
     }
 
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/vmix/vmix.c oss-v4.1test0-070624-src-gpl/kernel/drv/vmix/vmix.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/vmix/vmix.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/vmix/vmix.c	Tue Jun 26 22:19:42 2007
@@ -65,7 +65,7 @@
   int vol;
 
   if (mixer == NULL)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   if (cmd == SNDCTL_MIX_READ)
     {
@@ -90,7 +90,7 @@
 	  break;
 
 	default:
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 	}
     }
 
@@ -114,11 +114,11 @@
 	  break;
 
 	default:
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 	}
     }
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static int
@@ -128,7 +128,7 @@
   int vol;
 
   if (mixer == NULL)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   if (cmd == SNDCTL_MIX_READ)
     {
@@ -149,7 +149,7 @@
 	  break;
 
 	default:
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 	}
     }
 
@@ -168,11 +168,11 @@
 	  break;
 
 	default:
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 	}
     }
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static int
@@ -183,10 +183,10 @@
   int vol, rvol;
 
   if (mixer == NULL)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   if (ctrl < 0 || ctrl >= mixer->num_clientdevs)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   portc = mixer->client_portc[ctrl];
 
@@ -209,7 +209,7 @@
       return vol | (vol << 16);
     }
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static int
@@ -220,13 +220,13 @@
   int val;
 
   if (mixer == NULL)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   if (cmd != SNDCTL_MIX_READ)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   if (ctrl < 0 || ctrl >= mixer->num_clientdevs)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   portc = mixer->client_portc[ctrl];
 
@@ -465,9 +465,9 @@
     case SNDCTL_DSP_SET_PLAYTGT:
       val = (*arg) * 2;
       if (val < 0)
-	return -EIO;
+	return RETERR(EIO);
       if (val >= mixer->play_engine.channels)
-	return -EIO;
+	return RETERR(EIO);
       portc->play_choffs = val;
       return *arg = val / 2;
       break;
@@ -523,9 +523,9 @@
     case SNDCTL_DSP_SET_RECSRC:
       val = (*arg) * 2;
       if (val < 0)
-	return -EIO;
+	return RETERR(EIO);
       if (val >= mixer->record_engine.channels)
-	return -EIO;
+	return RETERR(EIO);
       portc->rec_choffs = val;
       return *arg = val / 2;
       break;
@@ -537,7 +537,7 @@
 	char *names = NULL;
 
 	if (mixer->inputdev == -1)
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 	names = audio_engines[mixer->inputdev]->inch_names;
 
 	memset (ei, 0, sizeof (*ei));
@@ -576,7 +576,7 @@
       }
       break;
     }
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void
@@ -768,14 +768,14 @@
   int start = 0;
 
   if (mode & portc->disabled_modes)
-    return -EACCES;
+    return RETERR(EACCES);
 
   MUTEX_ENTER_IRQDISABLE (mixer->mutex, flags);
 
   if (portc->open_mode != 0)
     {
       MUTEX_EXIT_IRQRESTORE (mixer->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   portc->open_mode = mode;
@@ -1040,7 +1040,7 @@
   dmap->dmabuf_phys = 0;
   dmap->dmabuf = KERNEL_MALLOC (MY_BUFFSIZE);
   if (dmap->dmabuf == NULL)
-    return -ENOSPC;
+    return RETERR(ENOSPC);
   dmap->buffsize = MY_BUFFSIZE;
 #endif
 
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/vortex/vortex.c oss-v4.1test0-070624-src-gpl/kernel/drv/vortex/vortex.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/vortex/vortex.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/vortex/vortex.c	Tue Jun 26 22:19:43 2007
@@ -733,7 +733,7 @@
 
   if (devc->midi_opened)
     {
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   devc->midi_input_intr = inputbyte;
@@ -781,7 +781,7 @@
 static int
 vortex_midi_ioctl (int dev, unsigned cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static midi_driver_t vortex_midi_driver = {
@@ -883,7 +883,7 @@
     }
 
 #endif
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 #ifdef USE_SRC
@@ -929,13 +929,13 @@
   if (portc->open_mode != 0)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   if (devc->open_mode & mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   devc->open_mode |= mode;
@@ -1390,7 +1390,7 @@
       cmn_err (CE_WARN,
 	       "Aureal Vortex: Allocated DMA buffer smaller than 8k\n");
       vortex_free_buffer (dev, dmap, direction);
-      return -ENOSPC;
+      return RETERR(ENOSPC);
     }
 #endif
 
@@ -1401,14 +1401,14 @@
 vortex_check_output (int dev)
 {
   cmn_err (CE_WARN, "Vortex: Input timed out\n");
-  return -EIO;
+  return RETERR(EIO);
 }
 
 static int
 vortex_check_input (int dev)
 {
   cmn_err (CE_WARN, "Vortex: Input timed out\n");
-  return -EIO;
+  return RETERR(EIO);
 }
 
 
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/vortex/vortex2.c oss-v4.1test0-070624-src-gpl/kernel/drv/vortex/vortex2.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/vortex/vortex2.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/vortex/vortex2.c	Tue Jun 26 22:19:43 2007
@@ -856,7 +856,7 @@
 
   if (devc->midi_opened)
     {
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   devc->midi_input_intr = inputbyte;
@@ -904,7 +904,7 @@
 static int
 vortex2_midi_ioctl (int dev, unsigned cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static midi_driver_t vortex2_midi_driver = {
@@ -1140,7 +1140,7 @@
     }
 
 #endif
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void vortex2_trigger (int dev, int state);
@@ -1189,13 +1189,13 @@
   if (portc->open_mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   if (devc->open_mode & mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   devc->open_mode |= mode;
@@ -1529,14 +1529,14 @@
 {
   cmn_err (CE_WARN, "Vortex2: Output timed out\n");
 
-  return -EIO;
+  return RETERR(EIO);
 }
 
 static int
 vortex2_check_input (int dev)
 {
   cmn_err (CE_WARN, "Vortex2: Input timed out\n");
-  return -EIO;
+  return RETERR(EIO);
 }
 
 static int
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/drv/ymf7xx/ymf7xx.c oss-v4.1test0-070624-src-gpl/kernel/drv/ymf7xx/ymf7xx.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/drv/ymf7xx/ymf7xx.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/drv/ymf7xx/ymf7xx.c	Tue Jun 26 22:19:43 2007
@@ -293,7 +293,7 @@
 static int
 ymf7xx_audio_ioctl (int dev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static void ymf7xx_audio_trigger (int dev, int state);
@@ -329,7 +329,7 @@
   if (portc->open_mode)
     {
       MUTEX_EXIT_IRQRESTORE (devc->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   portc->open_mode = mode;
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/framework/ac97/ac97.c oss-v4.1test0-070624-src-gpl/kernel/framework/ac97/ac97.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/framework/ac97/ac97.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/framework/ac97/ac97.c	Tue Jun 26 22:19:43 2007
@@ -147,9 +147,9 @@
 ac97_mixer_get (ac97_devc * devc, int dev)
 {
   if (dev < 0 || dev >= SOUND_MIXER_NRDEVICES)
-    return -EINVAL;
+    return RETERR(EINVAL);
   if (!((1 << dev) & devc->devmask))
-    return -EINVAL;
+    return RETERR(EINVAL);
   return devc->levels[dev];
 }
 
@@ -187,9 +187,9 @@
   int left, right, lvl;
 
   if (dev < 0 || dev >= SOUND_MIXER_NRDEVICES)
-    return -EINVAL;
+    return RETERR(EINVAL);
   if (!((1 << dev) & devc->devmask))
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   if (!((1 << dev) & STEREO_DEVS))
     {
@@ -299,7 +299,7 @@
       break;
 #endif
     default:
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 
   return devc->levels[dev] = value;
@@ -401,13 +401,13 @@
   int ret, ctrl;
 
   if (!devc->is_ok)
-    return -EIO;
+    return RETERR(EIO);
 
   ctrl = cmd & 0xff;
 
   if (ctrl < 0 || ctrl >= SOUND_MIXER_NRDEVICES
       || devc->overrides[ctrl] == NULL)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   ret = devc->overrides[ctrl] (devc->mixer_dev, audiodev, cmd, val);
   if (ret < 0)
@@ -469,7 +469,7 @@
 
 	value = *arg;
 	if (value != 0 && value != 1)
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 
 	tmp = codec_read (devc, 0x0e);
 
@@ -500,7 +500,7 @@
 
 	  default:
 	    if ((cmd & 0xff) > SOUND_MIXER_NRDEVICES)
-	      return -EINVAL;
+	      return RETERR(EINVAL);
 	    val = *arg;
 	    ctrl = cmd & 0xff;
 	    if (ctrl >= 0 && ctrl < SOUND_MIXER_NRDEVICES)
@@ -550,7 +550,7 @@
     }
   else
     {
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 }
 
